(function() {
    printLog("inner_ad_manager begin");
	
	function _init() {
	    printLog("inner_ad_manager _init");
		
		// 初始化参数
		related_ad = document.getElementById("related_ad");
		
			
	    // 注册相关广告渲染接口
	    window.InnerBridge.registerHandler("jsFunctionRenderAd", window.InnerAdManager.jsFunctionRenderAd);
	
	    // 注册相关广告渲染接口
	    window.InnerBridge.registerHandler("jsFunctionSyncAdStatus", window.InnerAdManager.jsFunctionSyncAdStatus);
    }

	function _jsFunctionRenderAd(data, responseCallback) {
		var relatedAd = JSON.parse(data);
		printLog("inner_ad_manager _jsFunctionRenderAd");
		
		if (relatedAd && relatedAd.length > 0) {
		    related_ad.innerHTML = "";
			var tempHtml = "";
		    for(var i=0; i < relatedAd.length; i++){
				for (var j = 0; j < relatedAd[i].singles.length; j++) {
					var tindex = relatedAd[i].tindex;
					var sindex = relatedAd[i].singles[j].sindex;
					printLog("inner_ad_manager _jsFunctionRenderAd tindex:" + tindex);
					printLog("inner_ad_manager _jsFunctionRenderAd sindex:" + sindex);

					var imageUrl = relatedAd[i].singles[j].item.imageUrl;
					var largeImageUrl = relatedAd[i].singles[j].item.largeImageUrl;
					printLog("inner_ad_manager _jsFunctionRenderAd imageUrl:" + imageUrl);
					printLog("inner_ad_manager _jsFunctionRenderAd largeImageUrl:" + largeImageUrl);
					
					var patchedAppName = relatedAd[i].singles[j].item.patchedAppName;
					var patchedAdDesc = relatedAd[i].singles[j].item.patchedAdDesc;
					var buttonText = relatedAd[i].singles[j].item.buttonText;
					var patchedShortDesc = relatedAd[i].singles[j].item.patchedShortDesc;
					var bannerClick = relatedAd[i].singles[j].item.bannerClick;
					printLog("inner_ad_manager _jsFunctionRenderAd patchedAppName:" + patchedAppName);
					printLog("inner_ad_manager _jsFunctionRenderAd patchedAdDesc:" + patchedAdDesc);
					printLog("inner_ad_manager _jsFunctionRenderAd buttonText:" + buttonText);
					printLog("inner_ad_manager _jsFunctionRenderAd patchedShortDesc:" + patchedShortDesc);
					printLog("inner_ad_manager _jsFunctionRenderAd bannerClick:" + bannerClick);
					
					var icon_id = "icon_id_tindex_" + relatedAd[i].tindex + "_sindex_" + relatedAd[i].singles[j].sindex;
					var app_name_id = "app_name_id_tindex_" + relatedAd[i].tindex + "_sindex_" + relatedAd[i].singles[j].sindex;
					var button_id = "button_id_tindex_" + relatedAd[i].tindex + "_sindex_" + relatedAd[i].singles[j].sindex;
					var large_image_id = "large_image_id_tindex_" + relatedAd[i].tindex + "_sindex_" + relatedAd[i].singles[j].sindex;
					printLog("inner_ad_manager _jsFunctionRenderAd icon_id:" + icon_id);
					printLog("inner_ad_manager _jsFunctionRenderAd app_name_id:" + app_name_id);
					printLog("inner_ad_manager _jsFunctionRenderAd button_id:" + button_id);
					printLog("inner_ad_manager _jsFunctionRenderAd large_image_id:" + large_image_id);
					
					// icon
					tempHtml += "<div class='ad_inner'>";
						tempHtml += "<div class='ad_inner_head'>";
							tempHtml += "<div class='ad_inner_icon'>";
							if (bannerClick == 1) {
								tempHtml += "<img class='footer_ads_icon' id='"  + icon_id + "'" + " tindex='" + tindex + "' sindex='" + sindex + "'" + " src='" + imageUrl + "' width='48px' height='48px'/>";
							} else {
								tempHtml += "<img class='footer_ads_icon' id='"  + icon_id + "'" + " tindex='" + tindex + "' sindex='" + sindex + "'" + " onClick='InnerAdManager.clickImage.call(this)'" + " src='" + imageUrl + "' width='48px' height='48px'/>";
							}
							tempHtml += "</div>"
							
							// app_name
							var width = document.body.clientWidth;
							if (width >= 360) {
								tempHtml += "<div class='ad_inner_title_big'>";
							} else {
								tempHtml += "<div class='ad_inner_title_small'>";
							}
							if (bannerClick == 1) {
							    tempHtml += "<div class='ad_inner_name' id='" + app_name_id + "'" + " tindex='" + tindex + "' sindex='" + sindex + "'" + " onClick='InnerAdManager.clickImage.call(this)'>" + patchedAppName + "</div>";
							} else {
							    tempHtml += "<div class='ad_inner_name' id='" + app_name_id + "'" + " tindex='" + tindex + "' sindex='" + sindex + "'>" + patchedAppName + "</div>";
							}
							tempHtml += "<div class='ad_inner_people'>" + patchedAdDesc + "</div>";
							tempHtml += "</div>";
							
							// button
							if (buttonText && buttonText != null) {
								tempHtml += "<div class='ad_inner_button' id='" + button_id + "'" + " tindex='" + tindex + "' sindex='" + sindex + "'" + " onClick='InnerAdManager.clickButton.call(this)'" + ">" + buttonText + "</div>";
							} else {
								tempHtml += "<div class='ad_inner_button' id='" + button_id + "'" + " tindex='" + tindex + "' sindex='" + sindex + "'" +  " onClick='InnerAdManager.clickButton.call(this)'" + ">下载</div>";
							}
							tempHtml += "<div style='clear:both;height:0px;'></div>";
						tempHtml += "</div>";
						
						// large_image
						tempHtml += "<div class='ad_inner_body'>";
							tempHtml += "<div class='ad_inner_body_float'>";
								if (bannerClick == 1) {
									tempHtml += "<img id='" + large_image_id + "'" + " tindex='" + tindex + "' sindex='" + sindex + "'" + " onClick='InnerAdManager.clickImage.call(this)' src='" + largeImageUrl + "'/>"
								} else {
									tempHtml += "<img id='" + large_image_id + "'" + " tindex='" + tindex + "' sindex='" + sindex + "'" + " src='" + largeImageUrl + "'/>"
								}
								tempHtml += "<div class='ad_message'>" + patchedShortDesc + "</div>";
							tempHtml += "</div>";
							tempHtml += "<div style='clear:both;height:0px;'></div>";
						tempHtml += "</div>";
					tempHtml += "</div>";
					
					related_ad_list.push(button_id);
				}
			}
			related_ad.innerHTML = tempHtml;
		}

		if (responseCallback) {
			responseCallback("inner_ad_manager _jsFunctionRenderAd ret");
		}
	}
	
	function _jsFunctionSyncAdStatus(data, responseCallback) {
		var adStatus = JSON.parse(data);
		printLog("inner_ad_manager _jsFunctionSyncAdStatus buttonText:" + adStatus.buttonText);
		printLog("inner_ad_manager _jsFunctionSyncAdStatus tIndex:" + adStatus.tindex);
		printLog("inner_ad_manager _jsFunctionSyncAdStatus sindex:" + adStatus.sindex);
		if (adStatus) {
		    var button_id = "button_id_tindex_" + adStatus.tindex + "_sindex_" + adStatus.sindex;
		    var relateButton = document.getElementById(button_id);
			if (relateButton) {
			    relateButton.innerHTML = adStatus.buttonText;
				if (adStatus.status == '9' || adStatus.status == '10' || adStatus.status == '11' || adStatus.status == '12') {
					relateButton.className = "ad_inner_button_orange";
				}
			}
		}

		if (responseCallback) {
			responseCallback("inner_ad_manager _jsFunctionSyncAdStatus ret");
		}
	}
	
	function _clickButton() {
		printLog("inner_ad_manager _clickRelateAd id:" + this.getAttribute("id"));
	    printLog("inner_ad_manager _clickRelateAd tindex:" + this.getAttribute("tindex"));
		printLog("inner_ad_manager _clickRelateAd sindex:" + this.getAttribute("sindex"));
		window.InnerBridge.callHandler("funcAdClick", "{click_type:0,tindex:" + this.getAttribute("tindex") + ",sindex:" + this.getAttribute("sindex") + "}", false);
	}
	
	function _clickImage() {
		printLog("inner_ad_manager _clickRelateAd id:" + this.getAttribute("id"));
	    printLog("inner_ad_manager _clickRelateAd tindex:" + this.getAttribute("tindex"));
		printLog("inner_ad_manager _clickRelateAd sindex:" + this.getAttribute("sindex"));
		window.InnerBridge.callHandler("funcAdClick", "{click_type:2,tindex:" + this.getAttribute("tindex") + ",sindex:" + this.getAttribute("sindex") + "}", false);
	}
	
	function _poolLoop() {
		printLog("inner_ad_manager _poolLoop size:" + related_ad_list.length);
		var storedAdSize = related_ad_list.length;
		if (storedAdSize > 0) {
			for (var i = 0; i < storedAdSize; i++) {
				var id = related_ad_list[i];
				if (id != null) {
					var ad = document.getElementById(id);
					if (ad && inView(ad)) {
					    var tindex = ad.getAttribute("tindex")
						var sindex = ad.getAttribute("sindex")
						window.InnerBridge.callHandler("funcAdPv", "{tindex:" + tindex + ",sindex:" + sindex + "}", false);
						related_ad_list.splice(i, 1);
						storedAdSize = related_ad_list.length;
						i--;
					}
				}
			}
		}
	}
	
	var InnerAdManager = window.InnerAdManager = {
	    init: _init,
		jsFunctionRenderAd: _jsFunctionRenderAd,
		jsFunctionSyncAdStatus:_jsFunctionSyncAdStatus,
		clickButton: _clickButton,
		clickImage: _clickImage,
		poolLoop:_poolLoop
    };
	
	var related_ad;
	var related_ad_list = [];
		
	var doc = document;
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('InnerAdManagerReady');
    doc.dispatchEvent(readyEvent);
	
	printLog("inner_ad_manager end");
})();